﻿#include "GameMain.h"
#include <stdio.h>

GameMain::GameMain(void)
{
}
GameMain::~GameMain(void)
{
}

void GameMain::OnInit()
{
	RECT rect;
	GetClientRect( m_hWnd, &rect );

	D3DVIEWPORT9 vp = {0, 0, rect.right - rect.left, rect.bottom - rect.top, 0.0f, 1.0f};

	m_Eye.x = 5.0f;
	m_Eye.y = 0.0f;
	m_Eye.z = -20.0f;
 
	m_At.x = 0.0f;
	m_At.y = 0.0f;
	m_At.z = 0.0f;
 
	m_Up.x = 0.0f;
	m_Up.y = 1.0f;
	m_Up.z = 0.0f;

	D3DXMatrixLookAtLH( &m_matView, &m_Eye, &m_At, &m_Up );
	pd3dDevice->SetTransform( D3DTS_VIEW, &m_matView );

	D3DXMatrixPerspectiveFovLH( &m_matProj, D3DX_PI / 4, 1.0f, 1.0f, 100.0f );
	pd3dDevice->SetTransform( D3DTS_PROJECTION, &m_matProj );
	pd3dDevice->SetViewport( &vp );

	pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	pd3dDevice->SetRenderState( D3DRS_FILLMODE, D3DFILL_WIREFRAME );

	D3DXCreateFont(pd3dDevice, 20, 0, FW_NORMAL, 1, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial", &Font);

	//Collider
	Sphere[0].fRadious = 1.0f;
	Sphere[0].fScaling = 1.0f;
	Sphere[0].vTrans = D3DXVECTOR3 (-2, 0, 0);

	Sphere[1].fRadious = 2.0f;
	Sphere[1].fScaling = 2.0f;
	Sphere[1].vTrans = D3DXVECTOR3 (4, 0, 0);

	D3DXCreateSphere( pd3dDevice, 1.0f, 20, 20, &Sphere[0].m_pMesh, NULL );
	D3DXCreateSphere( pd3dDevice, 1.0f, 20, 20, &Sphere[1].m_pMesh, NULL );

	isCrash=false;
}

void GameMain::OnRender()
{	
	D3DXMATRIX matWorld, matScale, matTrans;

	char string[20];
	RECT rt = {10, 10, 0, 0};
	if(isCrash)
		sprintf(string, "Crash : TRUE");
	else
		sprintf(string, "Crash : FALSE");
	Font->DrawText(NULL, string, -1, &rt, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f));


	for(int i=0; i<2; i++)
	{
		D3DXMatrixTranslation(&matTrans, Sphere[i].vTrans.x, Sphere[i].vTrans.y, Sphere[i].vTrans.z);
		D3DXMatrixScaling(&matScale, Sphere[i].fScaling, Sphere[i].fScaling, Sphere[i].fScaling);
		matWorld = matScale * matTrans;
		pd3dDevice->SetTransform(D3DTS_WORLD, &matWorld);
		Sphere[i].m_pMesh->DrawSubset(0);
	}
}

void GameMain::OnUpdate()
{
	Key_Update();
	isCrash=Sphere[0].CheckIntersect(Sphere[1]);
}

void GameMain::OnRelease()
{
	//m_Shape.OnRelease();
	if(Font)
		Font->Release();
}

/*bool GameMain::CheckIntersect(Collider Sphere1, Collider Sphere2)
{
	float distance;
	D3DXVECTOR3 gap;

	gap = Sphere1.vTrans - Sphere2.vTrans;
	distance = D3DXVec3LengthSq(&gap);
	if(distance <= (Sphere1.fRadious + Sphere2.fRadious)*(Sphere1.fRadious + Sphere2.fRadious))
		return true; 
	return false;
}*/